# Using TurtleStitch Without an Internet Connection

TurtleStitch is a web application hosted at
[https://www.turtlestitch.org/](https://www.turtlestitch.org/ "TurtleStitch.org").
   
If you would like to use TurtleStitch without being connected to the internet, e.g. in a remote area
or in a school with limited or unreliable online service you can easily set up TurtleStitch locally on
your computer, by following these

## Simple Steps:

1. Download the latest TurtleStitch Release from
[https://github.com/backface/turtlestitch/releases/latest](https://github.com/backface/turtlestitch/releases/latest "TurtleStitch Source Code"), and unpack the contents of the archive to your local disk.
2. Open the file `index.html` in your browser.
3. There is no step 3.

TurtleStitch is just a web page, you can open it locally in your browser, no need to install anything
on your computer. You can use whichever operating system you like, you don't even need
admin rights. You can also use a memory stick to distribute the directory with source files
among the participants of a workshop or the students of your class, even if some of them
are using MacOS and others run MS Windows or Linux. 

## Remember to Unpack

Windows users, this is for you.

Once you've downloaded the source code, please remember to actually unpack the archive
to your computer. If you downloaded the zip file please actually unzip it, before you open
`index.html`. If you use a Mac simple double-clicking the zip file unpacks it. But if you're
on Windows double clicking the zip fie will *not* unzip it but instead show you the contents of
the archive.

## Which Web Browser?

It's best to open TurtleStitch in Chrome or Firefox.

TurtleStitch is using web standards and runs in any modern web browser. Some browsers are faster
than others, which makes using TurtleStitch more fun. For the best user experience we recommend
Chrome or Firefox. IE does not comply with modern web standards and will not work. Edge
will work, but some operations will be so slow it takes the fun out of programming and playing. 

## What about Tablets?

We don't recommend it.

TurtleStitch sorta runs on tablets, but the UI isn't optimized for mobile use. Also, many mobile
web browsers enforce some restrictions that are not web-standards compliant, e.g. they
will not support the soft keyboard or intentionally slow down certain operations to discourage
using web apps in favor of proprietary "native" apps.

## Restrictions of the Offline Version

You can't access the cloud, duh. Everything else just works.

Aside from accessing the cloud using TurtleStitch offline in the browser by opening the `index.html`
file locally there aren't any restrictions. You can use all the blocks, import pictures, sounds,
libraries, take snapshots with the webcom, record sounds with the microphone, draw your
own costumes etc.

## Saving and Loading

When you use TurtleStitch locally you will not be able to save projects to the cloud, nor can you
access projects saved in the cloud. Instead projects will be exported as xml-files to your
computer, from where they can also be opened again.

There are two ways to load projects and assets from your computer when you use TurtleStitch
without an internet connection:

1. Using the options in TurtleStitch's file menu opens an OS-native file dialog that lets you select
which file to import or load.
2. Alternatively you can drag projects and assets (extension libraries, pictures, sounds etc.)
from your computer directly into TurtleStitch and drop it. If you import sounds or images you can
also drag and drop several files all at once.

Easy, isn't it?

## Keeping TurtleStitch up-to-date

From time to time it's wise to check whether a new version of TurtleStitch is available. You can
find out the lastest release using the link above, and compare that to the offline sources on
your computer. If there is a newer version, simply replace the source files with the newer ones.


Enjoy!

-Jens
